#!/bin/sh
#this is a UniVPN of install script
#unset LD_PRELOAD

#############Install package infomation ##########
ProductVersionString=348
SystemBits=64

#############get root right##########
if [ `whoami` != "root" ]
then
    echo "the current user is not root,please install with root !";
    exit;
fi

#############get Option #####
OptionInstall=$1

#############confirm architecture#####
ARCH="`arch`"
if [ "$ARCH" = "i386" ]; then
    FLAG="x86"
elif [ "$ARCH" = "i486" ]; then
    FLAG="x86"
elif [ "$ARCH" = "i586" ]; then
    FLAG="x86"
elif [ "$ARCH" = "i686" ]; then
    FLAG="x86"
elif [ "$ARCH" = "x86_64" ]; then
    FLAG="x86"
elif [ "$ARCH" = "aarch64" ]; then
    FLAG="aarch64"
elif [ "$ARCH" = "mips64" ]; then
    FLAG="mips64"
else
    FLAG="UNKNOWN"
fi

if [ "$ARCH" != "x86_64" ] && [ "$ARCH" != "aarch64" ] && [ "$ARCH" != "mips64" ] ; then
    echo "Only support 64 bit, Please download 32 bit installation package!"
    exit;
fi

if [ "$FLAG" != "x86" ] && [ "$FLAG" != "aarch64" ] && [ "$FLAG" != "mips64" ] ; then
    echo "the VPNClient is not compatible with your computer!";
    exit;
fi

##########delete old secoclient##############
if [ -e /usr/local/SecoClient/uninstall.sh ];then
    /usr/local/SecoClient/uninstall.sh
fi

##########delete the content from /etc/profile##############
num=$(grep -n "#SecoClientPromoteServiceBegin" /etc/profile|cut -d : -f 1 | wc -w)
for i in `seq $num`
do
    sbegin=$(grep -n "#SecoClientPromoteServiceBegin" /etc/profile|cut -d : -f 1 | head -n 1)
    send=$(grep -n "#SecoClientPromoteServiceEnd" /etc/profile|cut -d : -f 1 | head -n 1)
    if [ -n "$sbegin" ]&&[ -n "$send" ];then
        sbeg=$((sbegin-1));
        sdelc=${sbeg}","${send}"d"
        sed -i $sdelc /etc/profile
    fi
done

##########check ui start######
#EXIST_STATUS_UI=`ps -ef | grep UniVPN$ | grep -v grep`
#if [ "${EXIST_STATUS_UI}" != "" ]; then
#    echo "UniVPN Client has been started, Please use pkill -9 UniVPN$ to close it before install!"    
#    exit 0
#fi
##########install choice######
EXIST_STATUS_PROMOTE_SERVICE=`ps -ef | grep UniVPNPromoteService | grep -v grep`
STRING_TMP=${EXIST_STATUS_PROMOTE_SERVICE#*/}
CURRENT_ANYACCESS_CLIENT_PATH=${STRING_TMP%/*/*};
CURRENT_ANYACCESS_UNINSTALL_PATH=/${CURRENT_ANYACCESS_CLIENT_PATH}
SAVE_CURRENT_PATH=`pwd`
if [ "${EXIST_STATUS_PROMOTE_SERVICE}" != "" ]; then
    echo "UniVPN Client has been already installed in \"${CURRENT_ANYACCESS_UNINSTALL_PATH}\", Would you like to uninstall it and install new one?(Y/N)"
    if [ "${OptionInstall}" = "S" ]; then
        choice="S"
    else
        read choice
    fi
    if [ "${choice}" = "y" ] || [ "${choice}" = "Y" ] || [ "${choice}" = "S" ]; then
        cd /etc/init.d
        bash UniVPNPromoteService.sh stop
        OS=`cat /etc/*-release`
        if [ "$OS" = "Ubuntu" ]; 
        then 
            update-rc.d -f UniVPNPromoteService.sh remove
        fi
        rm UniVPNPromoteService.sh
        
        #fix bug:40948 【mac】【10781.5.824.0815】处于连接状态，直接覆盖安装会导致dns残留 (不能强杀UniVPNCS 进程)
        ps -efww|grep -w '/usr/local/UniVPN/UniVPN'|grep -v grep|awk '{print $2}'|xargs kill -9 > /dev/null 2>&1
        ps -efww|grep -w 'UniVPNPromoteService'|grep -v grep|awk '{print $2}'|xargs kill -9  > /dev/null 2>&1

        if [ "${choice}" = "S" ]; then
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/component
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/driver
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/help
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/image
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/language
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/lib
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/plugins
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/promote
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/serviceclient
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/update
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/install.sh
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/qt.conf
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/UniVPN
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/UniVPNUpdate
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/sysconfig.ini
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}/uninstall.sh
        else
            rm -rf ${CURRENT_ANYACCESS_UNINSTALL_PATH}
        fi
		
		##########delete the content from /etc/profile##############
        num=$(grep -n "#UniVPNPromoteServiceBegin" /etc/profile|cut -d : -f 1 | wc -w)
        for i in `seq $num`
        do
            sbegin=$(grep -n "#UniVPNPromoteServiceBegin" /etc/profile|cut -d : -f 1 | head -n 1)
            send=$(grep -n "#UniVPNPromoteServiceEnd" /etc/profile|cut -d : -f 1 | head -n 1)
            if [ -n "$sbegin" ]&&[ -n "$send" ];then
                sbeg=$((sbegin-1));
                sdelc=${sbeg}","${send}"d"
                sed -i $sdelc /etc/profile
            fi
        done
		update-icon-caches /usr/share/icons/*
        cd ${SAVE_CURRENT_PATH}
    else
        exit 0
    fi
fi


#CS 可能没有自动退出
EXIST_STATUS_CS=`ps -ef | grep UniVPNCS | grep -v grep`   
if [ "${EXIST_STATUS_CS}" != "" ]; then
    echo  "Wait for CS to exit..."
    sleep 4
    if [ "${EXIST_STATUS_CS}" != "" ]; then
        sleep 2
        ps -efww|grep -w 'UniVPNCS'|grep -v grep|awk '{print $2}'|xargs kill -9  > /dev/null 2>&1
        echo  "cs exit..."
    fi
fi

###########tar zip############
lines=265 #lines is the length of this script + 1
mkdir tmp
tail -n +$lines $0 > ./UniVPN.tar.gz #write the file to /tmp from row 'lines'
tar -zxvf ./UniVPN.tar.gz -C ./tmp #decompression the file in /tmp to /V5R2UI

CUR_DIR=/usr/local
DESTDIR=${CUR_DIR}/UniVPN #destination directory to install V5R2UI
CERT=${DESTDIR}/certificate
if [ ! -d $DESTDIR ];then
    mkdir $DESTDIR
fi
if [ ! -d $CERT ];then
    mkdir $CERT
fi
cp -Rf ./tmp/* $DESTDIR
chmod a+x $DESTDIR/UniVPN #add executable right to all users

rm -rf tmp
rm UniVPN.tar.gz

################################################################
################################################################
DESKTOP_FILE=$DESTDIR/image/UniVPN.desktop
EXEC_FILE="Exec=$DESTDIR/UniVPN"
EXEC_PATH="Path=$DESTDIR"
EXEC_ICON="Icon=$DESTDIR/image/logo.png"

sed -i "5a\\$EXEC_FILE" $DESKTOP_FILE
sed -i "6a\\$EXEC_PATH" $DESKTOP_FILE
sed -i "7a\\$EXEC_ICON" $DESKTOP_FILE

#create startup menu item
APPDIR="/usr/share/applications"
APPSHORTCUT="$APPDIR/UniVPN.desktop" 
if [ -d $APPDIR ]; then
    rm -f "$APPSHORTCUT"
    chmod a+rx "$DESTDIR/image/UniVPN.desktop"
    cp "$DESTDIR/image/UniVPN.desktop" "$APPSHORTCUT"
fi

#create desktop icon for each user
HOMEDIRS=`cut -d: -f6  /etc/passwd`
for HOMEDIR in $HOMEDIRS; do
    if [ -d "$HOMEDIR/桌面" ]; then
        DESKTOPSHOTCUT="$HOMEDIR/桌面/UniVPN.desktop"
        rm -f  "$DESKTOPSHOTCUT"
        cp "$DESTDIR/image/UniVPN.desktop" "$DESKTOPSHOTCUT"
    fi

    if [ -d "$HOMEDIR/Desktop" ] ; then
        DESKTOPSHOTCUT="$HOMEDIR/Desktop/UniVPN.desktop"
        rm -f  "$DESKTOPSHOTCUT"
        cp "$DESTDIR/image/UniVPN.desktop" "$DESKTOPSHOTCUT"
    fi

    if [ ! -d $HOMEDIR/.config/autostart ];then
        mkdir -p $HOMEDIR/.config/autostart
    fi 
    chmod -R 777 $HOMEDIR/.config/autostart
done

############Daemon AND Auto Start#######
PROMOTE_FILE_PATH=${DESTDIR}/promote/UniVPNPromoteService
echo DAEMON=${PROMOTE_FILE_PATH} >> ${DESTDIR}/promote/UniVPNPromoteService.tmp
cd ${DESTDIR}/promote
cat  PromoteServiceHeader.sh UniVPNPromoteService.tmp > UniVPNPromoteService.new
cat  UniVPNPromoteService.new PromoteServiceBody.sh > UniVPNPromoteService.newnew
mv UniVPNPromoteService.newnew UniVPNPromoteService.sh
chmod +x UniVPNPromoteService.sh
ln -f -t /etc/init.d ${DESTDIR}/promote/UniVPNPromoteService.sh #add hard link in /etc/init.d
OS=`cat /etc/*-release`
if [ "$OS" = "Ubuntu" ]; 
then
    update-rc.d UniVPNPromoteService.sh defaults 20
fi
bash /etc/init.d/UniVPNPromoteService.sh start
rm PromoteServiceHeader.sh PromoteServiceBody.sh UniVPNPromoteService.tmp UniVPNPromoteService.new

#add serv lunch to /etc/profile
echo '#!/bin/sh'>>/etc/profile
echo '#UniVPNPromoteServiceBegin'>>/etc/profile
echo '#Warnning Do not add any content between Begin and End'>>/etc/profile
echo 'ps -ef |grep UniVPNPromoteService |grep -v grep'>>/etc/profile
echo 'if [ $? -ne 0 ]'>>/etc/profile
echo 'then'>>/etc/profile
echo 'bash /etc/init.d/UniVPNPromoteService.sh start'>>/etc/profile
echo 'fi'>>/etc/profile
echo '#UniVPNPromoteServiceEnd'>>/etc/profile
chmod a+x /etc/profile

#银河麒麟授信
if [ -e /usr/sbin/kysec_set ];then
	kysec_set -n exectl -v trusted /usr/local/UniVPN/promote/UniVPNPromoteService
	kysec_set -n exectl -v trusted /etc/profile
	kysec_set -n exectl -v trusted /usr/local/UniVPN/UniVPN
fi

# auto start after installation finished
echo "*****The program has been installed in directory UniVPN of your home Directory!*****"
echo "*****Enjoy!*****"
cd $DESTDIR/..
chmod -R 777 UniVPN
DESKUSE=`who |cut -d ' ' -f1 | head -n 1`
chown $DESKUSE "$DESKTOPSHOTCUT"
chmod o-w "$DESKTOPSHOTCUT"
cd $DESTDIR
cd ${DESTDIR}/serviceclient
chmod u+s UniVPNCS
mv ./libgmcrypto.so /lib
chmod 711 /usr/local/UniVPN/uninstall.sh
exit